/***********************************************************************
*                                                                      *
*               This software is part of the ast package               *
*           Copyright (c) 2003-2006 AT&T Knowledge Ventures            *
*                      and is licensed under the                       *
*                  Common Public License, Version 1.0                  *
*                      by AT&T Knowledge Ventures                      *
*                                                                      *
*                A copy of the License is available at                 *
*            http://www.opensource.org/licenses/cpl1.0.txt             *
*         (with md5 checksum 059e8cd6165cb4c31e351f2b69388fd9)         *
*                                                                      *
*              Information and Software Systems Research               *
*                            AT&T Research                             *
*                           Florham Park NJ                            *
*                                                                      *
*                 Glenn Fowler <gsf@research.att.com>                  *
*                  David Korn <dgk@research.att.com>                   *
*                   Phong Vo <kpv@research.att.com>                    *
*                                                                      *
***********************************************************************/
#pragma prototyped

/*
 * identify encoding given first block of encoded data
 * not all encodings are expected to self-identify
 */

#include <codex.h>

Codexmeth_t*
codexid(const void* head, size_t headsize, char* name, size_t namesize)
{
	register Codexmeth_t*	meth;

	for (meth = codexlist(NiL); meth; meth = codexlist(meth))
		if (meth->identf && (*meth->identf)(meth, head, headsize, name, namesize))
			return meth;
	return 0;
}
